<?
/*
WEBFRONT-ACTION-SCRIPT fuer S7-Instanzen

Release: 0.3
ReleaseDate: 06.06.2015

ReleaseNote:
16.01.2014 - R0.1 - tgusi74
 + Scriptmuster erstellt
 
14.03.2015 - R0.2 - tgusi74
 + Instanzpruefungen und Logging ==> dient nur der Fehlersuche
 + $_IPS['INSTANCE']     = ID der auslsenden WebServer Instanz
 + $_IPS['CONFIGURATOR'] = ID des aktuell genutzten Konfigurators
   ==> wird fuer WFC_SendNotification benoetigt
   
06.06.2015 - R0.3 - tgusi74
 + Wenn Schreibfehler auftritt,
	wird Schnitttstelle geschlossen und erneut versucht das Script zu starten
	==> es sollte dann der RECONNECT passieren

*/

if($_IPS['SENDER'] == "WebFront")
{
 $S7_Instanz_ID = IPS_GetParent($_IPS['VARIABLE']);

 if ($S7_Instanz_ID >= 1)
    {
     if (IPS_GetInstance($S7_Instanz_ID)['ModuleInfo']['ModuleID'] == "{932076B1-B18E-4AB6-AB6D-275ED30B62DB}")
         {
         //SIEMENS ADDRESS - Objekt
         $LoopCount=0;
         LB_LOOP:

         $instance = IPS_GetInstance($S7_Instanz_ID);
         $instanceConnect = IPS_GetInstance($instance['ConnectionID']);
         
         //Check ob Verbindung besteht ??
         $ReconnectCounter = 0;
         while (IPS_GetProperty($instance['ConnectionID'], 'Open') == false)
                {
                 $ret = IPS_SetProperty($instance['ConnectionID'],'Open',true);
                 IPS_ApplyChanges($instance['ConnectionID']);

                 IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                "Try to connect S7-ConnectInstanzID = " . $instance['ConnectionID'] . " ... '" . (int)$ret ."'");
                 IPS_Sleep(500);
                 
                 $ReconnectCounter = $ReconnectCounter + 1;
                 if ($ReconnectCounter >=2)
                    {
                     //Keine Verbindung moeglich ==> ABBRUCH !!
                     IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                    "ERROR: Kein Verbindungsaufbau zur S7 moeglich !! --> ConnectInstanzID=" . $instance['ConnectionID']);

                     WFC_SendNotification($_IPS['CONFIGURATOR'],
                                          $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']),
                                          "ERROR: Kein Verbindungsaufbau zur S7 moeglich !! --> InstanzID=" . $instance['ConnectionID'],
                                          "Warning",
                                          5);

                     //S7-Verbindung sicherheitshalber abbauen
                     IPS_SetProperty($instance['ConnectionID'],'Open',false);
                     IPS_ApplyChanges($instance['ConnectionID']);
                     return false;
                    }
                }
                     
         //Check ob S7-Instanz okay ???
         $instance = IPS_GetInstance($S7_Instanz_ID);
         if ($instance['InstanceStatus'] >= 104)
            {
             IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                            "ERROR: S7-Instanzenfehler aufgetreten !! --> '" . $instance['InstanceStatus'] . "'");

             WFC_SendNotification($_IPS['CONFIGURATOR'],
                                  $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']),
                                  "ERROR: S7-Instanzenfehler aufgetreten !! --> '" . $instance['InstanceStatus'] . "'",
                                  "Warning",
                                  5);
            }


         //Check ob Verbindungsinstanz zur Steuerung wirklich steht ???
         $instanceConnect = IPS_GetInstance($instance['ConnectionID']);
         if ($instanceConnect['InstanceStatus'] >= 104)
            {
             IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                            "ERROR: S7-Verbindungsinstanzenfehler aufgetreten !! --> '" . $instanceConnect['InstanceStatus'] . "'");

             WFC_SendNotification($_IPS['CONFIGURATOR'],
                                  $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']),
                                  "ERROR: S7-Verbindungsinstanzenfehler aufgetreten !! --> '" . $instanceConnect['InstanceStatus'] . "'",
                                  "Warning",
                                  5);
            }
            

         $S7_DataType = IPS_GetProperty($S7_Instanz_ID,"DataType");

            if ($S7_DataType == 0)
                {
                 $ret = @S7_WriteBit($S7_Instanz_ID, _ConvertToBoolean($_IPS['VALUE']));
                }
            else if ($S7_DataType == 1)
                {
                 $ret = @S7_WriteByte($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else if ($S7_DataType == 2)
                {
                 $ret = @S7_WriteWord($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else if ($S7_DataType == 3)
                {
                 $ret = @S7_WriteDWord($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else if ($S7_DataType == 4)
                {
                 $ret = @S7_WriteShortInt($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else if ($S7_DataType == 5)
                {
                 $ret = @S7_WriteSmallInt($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else if ($S7_DataType == 6)
                {
                 $ret = @S7_WriteInteger($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else if ($S7_DataType == 7)
                {
                 $ret = @S7_WriteReal($S7_Instanz_ID, $_IPS['VALUE']);
                }
            else
                {
                 $ret = false;
                }

            if ($ret == true)
                {
                 //Schreiben erfolgreich

                 S7_RequestRead($S7_Instanz_ID);

                 //somit muesste ja jetzt die Variablenaktualisierung im WF passieren,
                 //wie wenn SetValue($_IPS['VARIABLE'], $_IPS['VALUE']) gemacht wird !!

                 IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                "INFOMELDUNG ==> " .
                                "Instanzzustand = '" . $instance['InstanceStatus'] . "' " .
                                "Connectzustand = '" . $instanceConnect['InstanceStatus'] . "' " .
                                "Instanzzustand NEU = '" . IPS_GetInstance($S7_Instanz_ID)['InstanceStatus'] . "' " .
                                "Connectzustand NEU = '" . IPS_GetInstance($instance['ConnectionID'])['InstanceStatus'] . "' " );

                }
            else
                {
                 //Fehler bei Schreiben der S7
                 IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                "Fehler bei schreiben zur S7 mit Typ " . $S7_DataType . " - Wert = " . $_IPS['VALUE']);

                 IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                "FEHLERMELDUNG ==> " .
                                "Instanzzustand = '" . $instance['InstanceStatus'] . "' " .
                                "Connectzustand = '" . $instanceConnect['InstanceStatus'] . "' " .
                                "Instanzzustand NEU = '" . IPS_GetInstance($S7_Instanz_ID)['InstanceStatus'] . "' " .
                                "Connectzustand NEU = '" . IPS_GetInstance($instance['ConnectionID'])['InstanceStatus'] . "' " );

                 //InfoBox ans ausloesende Webfront schreiben !!!
                 WFC_SendNotification($_IPS['CONFIGURATOR'],
                                      $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']),
                                      "Fehler bei schreiben zur S7 mit Typ " .
                                      $S7_DataType . " - Wert = " . $_IPS['VALUE'] . " / " .
                                      "Instanzzustand = '" . $instance['InstanceStatus'] . "' " .
                                      "Connectzustand = '" . $instanceConnect['InstanceStatus'] . "' " .
                                      "Instanzzustand NEU = '" . IPS_GetInstance($S7_Instanz_ID)['InstanceStatus'] . "' " .
                                      "Connectzustand NEU = '" . IPS_GetInstance($instance['ConnectionID'])['InstanceStatus'] . "' ",
                                      "Information",
                                      3);

					 if ($LoopCount <= 0)
						 {
						  //Wenn ein Schreibfehler auftritt dann SCHNITTSTELLE schliessen und neu versuchen !!
						  $LoopCount++;
                    IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                   "FEHLERMELDUNG ==> Schliesse jetzt die Schnittstelle und versuche es neu");

                    $ret = IPS_SetProperty($instance['ConnectionID'],'Open',false);
                    IPS_ApplyChanges($instance['ConnectionID']);

                    IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']),
                                   "Try to connect S7-ConnectInstanzID = " . $instance['ConnectionID'] . " ... '" . (int)$ret ."'");

                    //InfoBox ans ausloesende Webfront schreiben !!!
                    WFC_SendNotification($_IPS['CONFIGURATOR'],
                                         $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']),
                                         "FEHLERMELDUNG ==> Schliesse jetzt die Schnittstelle und versuche es neu (" . $ret . ")",
                                         "Information",
                                         3);
 
					     goto LB_LOOP;
						 }

                }
         }
     else
         {
          IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']), "Instanz ist kein SIEMENS ADDRESS - Objekt");
         }
    }
 else
    {
      IPS_LogMessage($_IPS['SELF']. "_" . IPS_GetName($_IPS['SELF']), "Objekt hat keine Elternobjekt");
    }

}


//SUBFUNCTIONS !!!!

function _ConvertToBoolean($Value)
 {
     $Value = strtoupper($Value);

     if (in_array($Value,array('TRUE', 'YES', 'Y', '1', 'ON', 'EIN', 'J', 'JA', true, 1), true))
        {
         return true;
        }
     else
        {
         return false;
        }
 }

?>
